'*****************************************
'* Westfalia Kchenpanel                 *
'* GLCD Oberflche zur Anzeige von       *
'* Bordbatterie, Khlschranktemperatur,  *
'* Brauchwasserstand und Eis-Ex Funktion *
'* mit ATMEGA 8                          *
'* last update 04-09-2009                *
'* ICE-EX ist nun Khlschrankventilator  *
'*****************************************

$regfile = "m8def.dat"
$lib "Glcdks108.LBX"
$crystal = 8000000
$hwstack = 128
$swstack = 128
$framesize = 128

Config Graphlcd = 128 * 64sed , Dataport = Portd , Controlport = Portb , Ce = 3 , Ce2 = 4 , Cd = 5 , Rd = 0 , Reset = 2 , Enable = 1

Wait 1                                                      'GLCD initialisieren

Cls

'* Eingnge fr Wasserstandssensoren *

Ddrc.1 = 0
Pinc.1 = 0

Ddrc.2 = 0
Pinc.2 = 0

Ddrc.3 = 0
Pinc.3 = 0

Ddrc.4 = 0
Pinc.4 = 0

'* Pin fr Khlschrankventilator definieren *

Ddrb.6 = 0
Portb.6 = 1

Dim T1 As Single
Dim Temp_w As Word
Dim Count_remain As Word
Dim Count_per_degree As Word
Dim Deg As Byte
Dim Templong As Long
Dim Ar As Byte                                              'Variablenname und Typ festlegen
Dim Temperatur As Single                                    'Variablenname und Typ festlegen

Dim W As Word                                               'Variablenname und Typ festlegen
Dim Volt As Single                                          'Variablenname und Typ festlegen
Dim Volt_string As String * 16
Const Adc_multi = 0.0146484                                 '15 Volt / 1024 = 0.0146484
Const Cal = 2                                               ' Kalibrierung fr DS1820

Config Adc = Single , Prescaler = Auto , Reference = Avcc   'AD Eingang fr Spannungsmessung
Config Single = Scientific , Digits = 1                     'Ausgabe Spannungswert nur eine Stelle hinter Komma

Config 1wire = Portc.5                                      'DS1821 DQ an PC5

 Setfont Font6x8
 Lcdat 3 , 40 , "WESTFALIA"
 Lcdat 5 , 17 , "KUECHENPANEL V.1" , 1

 Wait 3
Cls Text

Showpic 1 , 1 , Maske1                                      'Displayoberflche

Setfont Font 6x8
Lcdat 5 , 4 , "Waterlevel" , 1
Lcdat 5 , 67 , "  COOLER  " , 1

Do

'* Spannungsmessung *

  Start Adc                                                 ' AD Wandler
 W = Getadc(0)
 Stop Adc
Volt = W * Adc_multi                                        '15 Volt / 1024 * 0.0146484
Volt_string = Str(volt)
Lcdat 3 , 26 , Volt_string
Lcdat 3 , 52 , "V"

'* Temperaturmessung *

1wreset
  1wwrite &HEE
  Waitms 500
  1wreset
    1wwrite &HAC                                            ' read status register,
  Ar = 1wread()
  Waitms 500
  1wreset
  1wwrite &HAA                                              ' and read
  Ar = 1wread()
  Waitms 500                                                ' measured value
  Deg = 0                                                   ' prepare sign variable
  If Ar.7 = 1 Then                                          ' if temperature is < 0
    Ar = 256 - Ar                                           ' convert it from 2nd complement
    Deg = 1
  End If                                                    ' (so far it was standard procedure).
    1wreset                                                 ' reset 1WIRE bus
    1wwrite &HA0                                            ' now read remaind part of DS1821 counter
    Waitms 200
    Count_remain = 1wread(2)                                ' (it is 9 bit long!)
    Waitms 200
    1wreset                                                 ' reset 1WIRE bus
    1wwrite &H41                                            ' send LOAD COUNTER command which prepares
    Waitms 200
    1wreset                                                 ' (reset 1WIRE bus)
    1wwrite &HA0                                            ' for reading the internal parameter
    Waitms 200
    Count_per_degree = 1wread(2)                            ' needed for further calculations (9 bits)
    Waitms 200
    Temp_w = Count_per_degree - Count_remain                ' '
    T1 = Count_per_degree                                   'For Temperatur >= 0:
    Temperatur = Temp_w / T1                                '                 Count_per_degree - Count_remain

    'T1 = Ar                                                 'Temperatur = ar - 1/2LSB + ------------------------------- /// Ohne Kalibrierung
    T1 = Ar + Cal                                           'Hier Wird Kalibriert

    If Deg = 0 Then                                         '                           Count_per_degree
        T1 = T1 - 0.5                                       '
        Temperatur = T1 + Temperatur                        'For Temperatur < 0:
    Else                                                    '                 Count_per_degree - Count_remain
        T1 = T1 + 0.5                                       'Temperatur = ar + 1/2LSB - -------------------------------
        Temperatur = T1 - Temperatur                        '                           Count_per_degree
    End If
    If Deg = 1 Then
    Lcdat 3 , 77 , "-"
    Else
    Lcdat 3 , 77 , "+"
    End If
    Lcdat 3 , 84 , Temperatur

'* Khlschrankventilator abfragen *

If Pinb.6 = 0 Then
Lcdat 7 , 100 , "OFF"
Else
Lcdat 7 , 100 , "   "
Lcdat 7 , 100 , "ON"
End If

'* Wasserstandsabfrage *

If Pinc.1 = 1 Then
 Lcdat 7 , 7 , "35-50 L"
Else
 If Pinc.2 = 1 Then
  Lcdat 7 , 7 , "25-35 L"
 Else
  If Pinc.3 = 1 Then
   Lcdat 7 , 7 , "10-25 L"
  Else
   If Pinc.4 = 1 Then
    Lcdat 7 , 11 , "5-10 L"
   Else
    Lcdat 7 , 7 , "       "
    Lcdat 7 , 14 , "EMPTY"
   End If
  End If
 End If
End If

Loop

$include "Font6x8.font"

Maske1:
 $bgf "maske1.bgf"